----------------------------
--      Constants         --
----------------------------

local CASTING_SOUND_FILE = "Interface\\AddOns\\FocusInterruptSounds\\casting.mp3"
local CC_SOUND_FILE = "Interface\\AddOns\\FocusInterruptSounds\\cc.mp3"
local INTERRUPTED_SOUND_FILE = "Interface\\AddOns\\FocusInterruptSounds\\interrupted.mp3"
local POLYMORPH_SOUND_FILE = "Interface\\AddOns\\FocusInterruptSounds\\sheep.mp3"
local INNERVATE_SOUND_FILE = "Interface\\AddOns\\FocusInterruptSounds\\innervate.mp3"

local SCHOOL_PHYSICAL	= 0x01;
local SCHOOL_HOLY	= 0x02;
local SCHOOL_FIRE	= 0x04;
local SCHOOL_NATURE	= 0x08;
local SCHOOL_FROST	= 0x10;
local SCHOOL_SHADOW	= 0x20;
local SCHOOL_ARCANE	= 0x40;
local SCHOOL_ALL	= 0x7F;

local DEFAULT_GLOBAL_OVERRIDES = 
[[Loken -> Lightning Nova
]];

local DEFAULT_BLACKLIST = 
[[-- PvP
* -> Arcane Explosion
* -> Avenger's Shield
* -> Chimera Shot
* -> Ghost Wolf
* -> Gnomish Lightning Generator
* -> Howl of Terror
* -> Immolate
* -> Mass Dispel
* -> Searing Pain
* -> Serpent Sting
* -> Shoot
* -> Slam
* -> Starfire
-- World: Northerend
Boneguard Scout -> *
Artruis the Heartless -> *
-- Dungeon: Anh'hahet
Prince Taldaram -> *
Amanitar -> *
-- Dungeon: Culling of Stratholme
Salramm the Fleshcrafter -> *
Mal'Ganis -> *
-- Dungeon: Drak'tharion Keep
Slad'ran -> *
Trollgore -> *
Novos the Summoner -> *
The Prophet Tharon'ja -> *
-- Dungeon: Forge of Souls
Bronjahm -> *
Spectral Warden -> *
-- Dungeon: Gundrak
Sla'dran -> *
Drakkari Battle Rider -> *
Eck the Ferocious -> *
-- Dungeon: Halls of Lightning
Unbound Firestorm -> Afterburn
Ionar -> *
Stormforged Giant -> *
-- Dungeon: Halls of Stone
Unrelenting Construct -> Short Circuit
-- Dungeon: Nexus
Azure Magus -> *
Keristrasza -> *
-- Dungeon: Oculus
Azure Ring Guardian -> *
Mage-Lord Urom -> *
Ley-Guardian Eregos -> *
-- Dungeon: Pit of Saron
Iceborn Proto-Drake -> *
-- Dungeon: Trial of the Champion
Eadric the Pure -> *
The Black Knight -> *
-- Dungeon: Utgarde Keep
Prince Keleseth -> *
Ingvar the Plunderer -> *
-- Dungeon: Utgarde Pinnacle
Massive Jormungar -> *
-- Dungeon: Violet Hold
Lavanthor -> *
Xevozz -> *
Cyanigosa -> *
-- Dungeon: Stonecore
High Priestess Azil -> Energy Shield
-- Dungeon: Vortex Pinnacle
Grand Vizier Ertan -> *
Altairus -> *
Asaad -> *
-- Raid: Black Temple
Ashtongue Elementalist -> *
Ashtongue Mystic -> *
Ashtongue Spiritbinder -> *
Ashtongue Stormcaller -> *
Bonechewer Blood Prophet -> *
Coilskar Sea-Caller -> *
Coilskar Soothsayer -> *
Dragon Turtle -> *
Shadowmoon Blood Mage -> *
Shadowmoon Deathshaper -> *
Lady Malande -> Empowered Smite
Lady Malande -> Divine Wrath
-- Raid: Eye of Eternity
Malygos -> *
-- Raid: Karazhan
Julianne -> Blinding Passion
Julianne -> Powerful Attraction
Shade of Aran -> Arcane Missiles
-- Raid: Naxxaramus
Death Knight Cavalier -> *
Unholy Staff -> *
Necro Knight -> *
Death Knight Captain -> *
Gothik the Harvester -> *
Living Monstrosity -> *
Sir Zeliek -> *
Baron Rivendare -> *
Lady Blaumeux -> *
Thane Korth'azz -> *
-- Raid: Obsidian Sanctum
Disciple of Shadron -> *
Disciple of Vesperon -> *
Onyx Blaze Mistress -> *
Onyx Sanctum Guardian -> *
Shadron -> *
Tenebron -> *
Vesperon -> *
Sartharion -> *
-- Raid: Sunwell Plateau
Sunblade Cabalist -> *
Sunblade Dusk Priest -> *
Felmyst -> *
-- Raid: Trial of the Crusader
Acidmaw -> *
Dreadscale -> *
-- Raid: Ulduar
Ignis -> *
Storm Tempered Keeper -> *
Misguided Nymph -> *
Corrupted Servitor -> *
Freya -> *
General Vezax -> Surge of Darkness
Sara -> *
Crusher Tentacle -> *
-- Raid: Vault of Archavon
Emalon the Storm Watcher -> *
-- Raid: Icecrown Citadel
The Lich King -> *
-- Raid: Bastion of Twilight
Halfus Wyrmbreaker -> Furious Roar
* -> Water Bomb
* -> Glaciate
]];

-- TODO: just consult a big list of spells
local DEFAULT_INTERRUPT_SPELLS =
[[
Arcane Torrent
Counterspell
Kick
Mind Freeze
Pummel
Rebuke
Shield Bash
Skull Bash
Silence
Spell Lock
Strangulate
Sunbeam
Wind Shear
]];

local DEFAULT_AURA_BLACKLIST = 
[[Shadow Trance -> Shadow Bolt
Backlash -> Shadow Bolt
Backlash -> Incinerate
Hot Streak -> Pyroblast
Fireball! -> Fireball
The Art of War -> Exorcism
Infusion of Light -> Flash of Light
Surge of Light -> Flash Heal
Surge of Light -> Smite
Nature's Swiftness -> *
Presence of Mind -> *
Divine Shield -> *
Divine Protection -> *
Burning Determination -> *
]];

local DEFAULT_INCOMING_CC = 
[[Cyclone
Fear
Polymorph
Seduction
]];

local DEFAULT_INCOMING_CC_LASHBACK = 
[[Polymorph
Seduction
]];

local DEFAULT_PARTNER_CC_MAGIC = 
[[Polymorph
Repentance
Seduction
]];

local DEFAULT_PARTNER_CC_POISON = 
[[Wyvern Sting
]];


local DEFAULT_ARENA_PURGE = 
[[Innervate
]];

local DEFAULT_PVE_PURGE = 
[[Pyrogenics
Remedy
Rune Shield
Runic Barrier
]];

local DEFAULT_CHANNELED_SPELLS =
[[Arcane Missiles
Charged Flurry
Divine Hymn
Drain Life
Drain Mana
Drain Soul
Energy Sap
Evocation
Flame Vents
Hymn of Hope
Lightning Whirl
Mind Flay
Mind Sear
Pain and Suffering
Penance
Tranquility
]];

------------------------------
--      Initialization      --
------------------------------

FocusInterruptSounds = LibStub("AceAddon-3.0"):NewAddon("FocusInterruptSounds", "AceEvent-3.0", "AceConsole-3.0")

local options = {
	type = "group",
	name = "FocusInterruptSounds",
	get = function(info) return FocusInterruptSounds.db.profile[ info[#info] ] end,
	set = function(info, value) FocusInterruptSounds.db.profile[ info[#info] ] = value end,
	args = {
		General = {
			order = 1,
			type = "group",
			name = "General Settings",
			desc = "General Settings",
			args = {
				intro = {
					order = 1,
					type = "description",
					name = "FocusInterruptSounds plays sounds when hostile targets cast interruptable spells. "
							.. "It also has other special sound events for PvP and PvE.  Found a bug?  Send a "
							.. "in-game mail to Corg, Horde, Detheroc, US PvP (chances are I won't be watching "
							.. "the Ace forums.",
				},

				fEnableText = {
					type = "toggle",
					name = "Enable text",
					desc = "Enable/disable chatframe text from FocusInterruptSounds.",
					order = 2,
				},
				fEnableSound = {
					type = "toggle",
					name = "Enable sound",
					desc = "Enable/disable sounds in FocusInterruptSounds.",
					order = 2,
				},
				fTargetFallback = {
					type = "toggle",
					name = "Target fallback",
					desc = "Allow interrupt sounds on target if not focus is set.",
					order = 3,
				},
				fPositiveReinforcement = {
					type = "toggle",
					name = "Positive reinforcement",
					desc = "Play a victory sound and show a victory message when you successfully interrupt.",
					order = 5,
				},
				fCheckSpellAvailability = {
					type = "toggle",
					name = "Check spell availibility",
					desc = "Require that the interrupt or anti-CC spell can be cast before generating a warning.",
					order = 6,
				},
				fDisableInVehicle = {
					type = "toggle",
					name = "Disable in vehcile",
					desc = "Turns off sounds while in a vehicle.",
					order = 7,
				},

				strGlobalOverrides = {
					type = "input",
					name = "Global Overrides",
					desc = "List of casters and spells should always generate a warning (even if they are not "
							.. "your target or focus), separated by a \"->\".  Use \"*\" to match any caster "
							.. "or any spell (but not both!).",
					order = 10,
					multiline = true,
					width = "double",
				},

				strBlacklist = {
					type = "input",
					name = "Caster -> Spell Blacklist",
					desc = "List of spells that should be ignored for a given caster, separated by a \"->\".  "
							.. "Use \"*\" to match any caster or any spell (but not both!).",
					order = 11,
					multiline = true,
					width = "double",
				},
				fIgnorePhysical = {
					type = "toggle",
					name = "Blacklist physical spells",
					desc = "Ignore spells classified as \"Physical.\"",
					order = 12,
				},
				strAuraBlacklist = {
					type = "input",
					name = "Aura -> Spell Blacklist",
					desc = "List of spells that should be ignored for a given aura, separated by a \"->\".  "
							.. "Use \"*\" to match any spell.",
					order = 13,
					multiline = true,
					width = "double",
				},

				strIncomingCC = {
					type = "input",
					name = "PvP Incoming CC Spells",
					desc = "List of spells that should sound a warning for incoming CC in arenas or nearby.",
					order = 14,
					multiline = true,
					width = "double",
				},

				strPartnerCC = {
					type = "input",
					name = "Arena Parner CC Debuffs",
					desc = "List of debuffs that should sound a warning if applied to your arena partner.",
					order = 15,
					multiline = true,
					width = "double",
				},

				strArenaPurge = {
					type = "input",
					name = "Arena Purge Buffs",
					desc = "List of buffs that should sound a warning when gained by an arena opponent.",
					order = 16,
					multiline = true,
					width = "double",
				},

				strPvePurge = {
					type = "input",
					name = "PvE Purge Buffs",
					desc = "List of buffs that should be purged from NPCs.",
					order = 17,
					multiline = true,
					width = "double",
				},

				strChanneledSpells = {
					type = "input",
					name = "Channeled Spells",
					desc = "List of spells that are channeled.  This affects the combat log parsing of this mod.",
					order = 18,
					multiline = true,
					width = "double",
				},
			},
		},
	},
};


function FocusInterruptSounds:OnInitialize()

	local strGlobalOverrides = DEFAULT_GLOBAL_OVERRIDES;
	local strAuraBlacklist = DEFAULT_AURA_BLACKLIST;
	local strIncomingCC = "";
	local strPartnerCC = "";
	local strPvePurge = "";

	_, self.strClassName = UnitClass("player");

	self.fIsPetInterrupt = false;
	self.fAntiCCIsLashback = false;
	self.fHasPurge = false;
	self.fCanDispel = false;
	self.fCanDepoison = false;

	if ("WARLOCK" == self.strClassName) then
		self.strInterruptSpellName = "Spell Lock";
		self.iInterruptSchool = SCHOOL_SHADOW;
		self.fIsPetInterrupt = true;
		self.str30YardSpellName = "Shoot";
		self.fHasPurge = true;
		self.fCanDispel = true;
	elseif ("MAGE" == self.strClassName) then
		self.strInterruptSpellName = "Counterspell";
		self.iInterruptSchool = SCHOOL_ARCANE;
		self.str30YardSpellName = "Shoot";
		self.fHasPurge = true;
	elseif ("SHAMAN" == self.strClassName) then
		self.strInterruptSpellName = "Wind Shear";
		self.iInterruptSchool = SCHOOL_NATURE;
		self.strAntiCCSpellName = "Grounding Totem";
		self.str30YardSpellName = "Lightning Bolt";
		self.fHasPurge = true;
		self.fCanDepoison = true;
	elseif ("WARRIOR" == self.strClassName) then
		self.strInterruptSpellName = "Pummel";
		self.iInterruptSchool = SCHOOL_PHYSICAL;
		self.str30YardSpellName = "Shoot";
	elseif ("ROGUE" == self.strClassName) then
		self.strInterruptSpellName = "Kick";
		self.iInterruptSchool = SCHOOL_PHYSICAL;
		self.strAntiCCSpellName = "Cloak of Shadows";
		self.str30YardSpellName = "Shoot";
	elseif ("PRIEST" == self.strClassName) then
		self.strInterruptSpellName = "Silence";
		self.iInterruptSchool = SCHOOL_SHADOW;
		self.strAntiCCSpellName = "Shadow Word: Death";
		self.fAntiCCIsLashback = true;
		self.str30YardSpellName = "Shadow Word: Pain";
		self.fHasPurge = true;
		self.fCanDispel = true;
		strGlobalOverrides = strGlobalOverrides .. "Felmyst -> Gas Nova\n";
	elseif ("HUNTER" == self.strClassName) then
		self.strInterruptSpellName = "Silencing Shot";
		self.iInterruptSchool = SCHOOL_PHYSICAL;
		self.strAntiCCSpellName = "Feign Death";
		self.str30YardSpellName = "Arcane Shot";
		self.fHasPurge = true;
	elseif ("DRUID" == self.strClassName) then
		self.strInterruptSpellName = "Skull Bash";
		self.iInterruptSchool = SCHOOL_PHYSICAL;
		self.str30YardSpellName = "Faerie Fire";
		self.fCanDepoison = true;
	elseif ("DEATHKNIGHT" == self.strClassName) then
		self.strInterruptSpellName = "Mind Freeze";
		self.iInterruptSchool = SCHOOL_FROST;
		self.strAntiCCSpellName = "Anti-Magic Shell";
		self.str30YardSpellName = "Strangulate";
	elseif ("PALADIN" == self.strClassName) then
		self.strInterruptSpellName = "Rebuke";
		self.fCanDispel = true;
		self.fCanDepoison = true;
	end

	-- Add additional auras for classes with physical interrupts
	if (self.iInterruptSchool == SCHOOL_PHYSICAL) then
		strAuraBlacklist = strAuraBlacklist .. "Hand of Protection -> *\n";
	end

	-- Set up incoming CC warning defaults
	if (nil ~= self.strAntiCCSpellName) then
		if (self.fAntiCCIsLashback) then
			strIncomingCC = DEFAULT_INCOMING_CC_LASHBACK;
		else
			strIncomingCC = DEFAULT_INCOMING_CC;
		end
	end

	-- Set up partner CC defaults
	if (self.fCanDispel) then
		strPartnerCC = strPartnerCC .. DEFAULT_PARTNER_CC_MAGIC;
	end

	if (self.fCanDepoison) then
		strPartnerCC = strPartnerCC .. DEFAULT_PARTNER_CC_POISON;
	end

	-- Set up purge defaults
	if (self.fHasPurge) then
		strPvePurge = DEFAULT_PVE_PURGE;
	end

	-- Build the default settings array
	local DEFAULTS = {
		profile = {
			fEnableText = true,
			fEnableSound = true,
			fTargetFallback = true,
			fPositiveReinforcement = true,
			fCheckSpellAvailability = true,
			fDisableInVehicle = true,

			strGlobalOverrides = strGlobalOverrides,
			strBlacklist = DEFAULT_BLACKLIST,
			fIgnorePhysical = false,
			strAuraBlacklist = strAuraBlacklist,
			strIncomingCC = strIncomingCC,
			strPartnerCC = strPartnerCC,
			strArenaPurge = DEFAULT_ARENA_PURGE,
			strPvePurge = strPvePurge,
			strChanneledSpells = DEFAULT_CHANNELED_SPELLS,
		}
	};
	self.db = LibStub("AceDB-3.0"):New("FocusInterruptSoundsDB", DEFAULTS, self.strClassName)

	options.args.Profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("FocusInterruptSounds", options)
	LibStub("AceConfigDialog-3.0"):SetDefaultSize("FocusInterruptSounds", 640, 480)
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("FocusInterruptSounds", nil, nil, "General")
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("FocusInterruptSounds", "Profile", "FocusInterruptSounds", "Profile")
	self:RegisterChatCommand("fis", function() LibStub("AceConfigDialog-3.0"):Open("FocusInterruptSounds") end)

end


function FocusInterruptSounds:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	self:CheckAndPrintMessage("Add-on activated for the class " .. self.strClassName);
end

function FocusInterruptSounds:OnDisable()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
end

------------------------------
--        Functions         --
------------------------------

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:CheckAndPrintMessage
--
--		Prints a message, only if the options permit it.
--
function FocusInterruptSounds:CheckAndPrintMessage(strMsg)

	if (self.db.profile.fEnableText) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff7fff7fFIS|r: " .. strMsg);
	end

end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:CheckAndPlaySound
--
--		Plays a sound, only if the options permit it.
--
function FocusInterruptSounds:CheckAndPlaySound(strFile)

	if (self.db.profile.fEnableSound) then
		PlaySoundFile(strFile);
	end

end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:FIsSourceFocusOrTarget
--
--		Returns true if the source flags are for the target we're making sounds for.
--
function FocusInterruptSounds:FIsSourceFocusOrTarget(iSourceFlags)

	-- Filter out non-hostile sources
	if (0 == bit.band(iSourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE)) then
		return false;
	end

	-- We want to react to focus actions
	if (0 ~= bit.band(iSourceFlags, COMBATLOG_OBJECT_FOCUS)) then

		
		spell, rank, displayName, icon, startTime, endTime, isTradeSkill, castID, notInterruptible = UnitCastingInfo("target")
		if (notInterruptable) then
			self:CheckAndPrintMessage("DEBUG: disabled sound because target is uninterruptable");

			return false;
		end


		return true;
	end

	-- If there is no hostile focus, allow fallback on the current target
	if (0 ~= bit.band(iSourceFlags, COMBATLOG_OBJECT_TARGET)
			and self.db.profile.fTargetFallback
			and not UnitCanAttack("player", "focus")
	) then

		spell, rank, displayName, icon, startTime, endTime, isTradeSkill, castID, notInterruptible = UnitCastingInfo("focus")
		if (notInterruptable) then
			self:CheckAndPrintMessage("DEBUG: disabled sound because focus is uninterruptable");

			return false;
		end

		return true;
	end

	return false;
end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:StrEscapeForRegExp
--
--		Returns the string escaped for use with LUA regular expressions.
--
function FocusInterruptSounds:StrEscapeForRegExp(str)

	-- Special characters: ^$()%.[]*+-?
	str = string.gsub(str, "%^", "%%%^");
	str = string.gsub(str, "%$", "%%%$");
	str = string.gsub(str, "%(", "%%%(");
	str = string.gsub(str, "%)", "%%%)");
	str = string.gsub(str, "%%", "%%%%");
	str = string.gsub(str, "%.", "%%%.");
	str = string.gsub(str, "%[", "%%%[");
	str = string.gsub(str, "%]", "%%%]");
	str = string.gsub(str, "%*", "%%%*");
	str = string.gsub(str, "%+", "%%%+");
	str = string.gsub(str, "%-", "%%%-");
	str = string.gsub(str, "%?", "%%%?");

	return str;

end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:FInList
--
--		Returns true if the given element is in the given newline-delimited list.
--
function FocusInterruptSounds:FInList(strElement, strList)

	--self:CheckAndPrintMessage("Looking for " .. strElement);

	return string.find("\n" .. strList .. "\n", "\n%s*" .. self:StrEscapeForRegExp(strElement) .. "%s*\n");

end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:FInMap
--
--		Returns true if the given key and value are in the given newline-delimited list.
--
function FocusInterruptSounds:FInMap(strKey, strValue, strMap)

	local strKeyEscaped;
	local strValueEscaped;

	if (nil == strKey) then
		strKeyEscaped = ".*";
	else
		strKeyEscaped = self:StrEscapeForRegExp(strKey);
	end

	if (nil == strValue) then
		strValueEscaped = ".*";
	else
		strValueEscaped = self:StrEscapeForRegExp(strValue);
	end

	return string.find("\n" .. strMap .. "\n", "\n%s*" .. strKeyEscaped
				.. "%s*%->%s*" .. strValueEscaped .. "%s*\n");

end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:FIsCasterOrSpellGlobalOverride
--
--		Returns true if the given spell (or cast+spell combo) is in the global override list.
--
function FocusInterruptSounds:FIsCasterOrSpellGlobalOverride(strMobName, iMobFlags, strSpellId, strSpellName, iSpellSchool)

	-- Is the spell in the global override?
	if (self:FInMap("*", strSpellName, self.db.profile.strGlobalOverrides)) then
		return true;
	end

	-- Only allow caster overrides for NPCs
	if (0 ~= bit.band(iMobFlags, COMBATLOG_OBJECT_CONTROL_NPC)) then
		-- Is the caster blacklisted?
		if (self:FInMap(strMobName, "*", self.db.profile.strGlobalOverrides)) then
			return true;
		end

		-- Is the caster+spell combo blacklisted?
		if (self:FInMap(strMobName, strSpellName, self.db.profile.strGlobalOverrides)) then
			return true;
		end
	end

	return false;

end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:FIsCasterOrSpellBlacklisted
--
--		Returns true if the given spell (or cast+spell combo) is blacklisted.
--
function FocusInterruptSounds:FIsCasterOrSpellBlacklisted(strMobName, iMobFlags, strSpellId, strSpellName, iSpellSchool)

	-- Blacklist physical spells
	if (self.db.profile.fIgnorePhysical and 0 ~= bit.band(iSpellSchool, SCHOOL_PHYSICAL)) then
		return true;
	end

	-- Is the spell blacklisted?
	if (self:FInMap("*", strSpellName, self.db.profile.strBlacklist)) then
		return true;
	end

	-- Only allow caster blacklists for NPCs
	if (0 ~= bit.band(iMobFlags, COMBATLOG_OBJECT_CONTROL_NPC)) then
		-- Is the caster blacklisted?
		if (self:FInMap(strMobName, "*", self.db.profile.strBlacklist)) then
			return true;
		end

		-- Is the caster+spell combo blacklisted?
		if (self:FInMap(strMobName, strSpellName, self.db.profile.strBlacklist)) then
			return true;
		end
	end

	return false;

end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:FIsAuraBlacklisted
--
--		Returns true if the given spell (or cast+spell combo) is blacklisted.
--
function FocusInterruptSounds:FIsAuraBlacklisted(strAura, strSpellId, strSpellName, iSpellSchool)

	-- self:CheckAndPrintMessage("id = " .. strSpellId .. "; spell name = " .. strSpellName);

	-- Is the aura blacklisted?
	if (self:FInMap(strAura, "*", self.db.profile.strAuraBlacklist)) then
		return true;
	end

	-- Is the aura+spell combo blacklisted?
	if (self:FInMap(strAura, strSpellName, self.db.profile.strAuraBlacklist)) then
		return true;
	end

	return false;

end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:FIsSpellCastStart
--
--		Returns true if the given event is the start of a spell cast.  Note that for channeled
--		spells, this is actually going to be SPELL_CAST_SUCCESS.
--
function FocusInterruptSounds:FIsSpellCastStart(strEventType, strSpellId, strSpellName, iSpellSchool)

	return ("SPELL_CAST_START" == strEventType
			or ("SPELL_CAST_SUCCESS" == strEventType
				and self:FInList(strSpellName, self.db.profile.strChanneledSpells)));

end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:FIsCCSpell
--
--		Returns true if the given event is the start of a CC.
--
function FocusInterruptSounds:FIsCCSpell(strSpellId, strSpellName, iSpellSchool)

	return self:FInList(strSpellName, self.db.profile.strIncomingCC);

end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:FHasBlacklistedAura
--
--		Returns true if the focus/target has an aura that will make the caster immune to
--		interrupts or will make the cast instant.
--
function FocusInterruptSounds:FHasBlacklistedAura(iSourceFlags, strSpellId, strSpellName, iSpellSchool)

	-- Go through recently cast buffs
	if (nil ~= self.lastInstacastSelfBuffName
		and GetTime() - self.lastInstacastSelfBuffTime < 1
		and self:FIsAuraBlacklisted(self.lastInstacastSelfBuffName, strSpellId, strSpellName, iSpellSchool)
	) then
		return true;
	end

	-- Go through the current buffs
	for i = 1, 40 do
		local strBuffName;

		if (0 ~= bit.band(iSourceFlags, COMBATLOG_OBJECT_FOCUS)) then
			strBuffName, _, _, _, _, _ = UnitBuff("focus", i);
		elseif (0 ~= bit.band(iSourceFlags, COMBATLOG_OBJECT_TARGET)) then
			strBuffName, _, _, _, _, _ = UnitBuff("target", i);
		end

		if (nil ~= strBuffName and self:FIsAuraBlacklisted(strBuffName, strSpellId, strSpellName, iSpellSchool)) then
			return true;
		end
	end

	return false;
end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:FIsPetSpellAvailable
--
--		Returns true if the pet can cast the given spell.
--
function FocusInterruptSounds:FIsPetSpellAvailable(strSpellName)


	-- Make sure the user wants these extra checks
	if (not self.db.profile.fCheckSpellAvailability) then
		return true;
	end

	-- Make sure that there is a spell
	if (nil == strSpellName) then
		return false;
	end

	-- Verify that the pet can act (i.e. isn't feared)
	if (not GetPetActionsUsable()) then
		return false;
	end

	-- Verify that the spell isn't on cooldown (also checks existence)
	iStartTime, _, fSpellEnabled = GetSpellCooldown(strSpellName, BOOKTYPE_PET);
	if (iStartTime ~= 0 or not fSpellEnabled) then
		return false;
	end

	-- Verify mana/energy
	_, _, _, iCost, _, _, _, _, _ = GetSpellInfo(strSpellName);
	if (UnitMana("playerpet") < iCost) then
		return false;
	end

	return true;
end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:FIsSpellAvailable
--
--		Returns true if you can cast the given spell.
--
function FocusInterruptSounds:FIsSpellAvailable(strSpellName)

	-- Make sure the user wants these extra checks
	if (not self.db.profile.fCheckSpellAvailability) then
		return true;
	end

	-- Make sure that there is a spell
	if (nil == strSpellName) then
		return false;
	end

	-- Verify that the spell isn't on cooldown
	iStartTime, _, fSpellEnabled = GetSpellCooldown(strSpellName);
	if (iStartTime ~= 0 or not fSpellEnabled) then
		return false;
	end

	-- Verify mana/energy
	_, _, _, iCost, _, _, _, _, _ = GetSpellInfo(strSpellName);
	if (UnitMana("player") < iCost) then
		return false;
	end

	return true;
end

---------------------------------------------------------------------------------------------------
--	FocusInterruptSounds:COMBAT_LOG_EVENT_UNFILTERED
--
--		Handler for combat log events.
--
function FocusInterruptSounds:COMBAT_LOG_EVENT_UNFILTERED(event, iTimestamp, strEventType, fHideCaster, strSourceGuid, strSourceName, iSourceFlags, strDestGuid, strDestName, iDestFlags, varParam1, varParam2, varParam3, varParam4, varParam5, varParam6, ...)

	local fHandled = false;

	-- Short circuit this processing if we're essentially disabled
	if (not self.db.profile.fEnableText and not self.db.profile.fEnableSound) then
		return
	end

	-- Track instacast buffs
	if (self:FIsSourceFocusOrTarget(iSourceFlags)
			and "SPELL_CAST_SUCCESS" == strEventType
			and self:FInMap(varParam2, nil, self.db.profile.strAuraBlacklist)
	) then
		self.lastInstacastSelfBuffName = varParam2;
		self.lastInstacastSelfBuffTime = GetTime();
	end

	-- Turn off all notifications while in a vehicle
	if (self.db.profile.fDisableInVehicle and UnitInVehicle("player")) then
		return
	end

	-- Global override sounds
	if (not fHandled
			and 0 ~= bit.band(iSourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE)
			and self:FIsSpellCastStart(strEventType, varParam1, varParam2, varParam3)
			and self:FIsCasterOrSpellGlobalOverride(strSourceName, iSourceFlags, varParam1, varParam2, varParam3)
	) then
		self:CheckAndPrintMessage(strSourceName .. " is casting |cffff4444" .. varParam2 .. "|r!");
		self:CheckAndPlaySound(CASTING_SOUND_FILE);
		fHandled = true;
	end

	-- Your partner is sheeped, play a sound
	if (not fHandled
			and 0 ~= bit.band(iDestFlags, COMBATLOG_OBJECT_AFFILIATION_PARTY)
			and 0 ~= bit.band(iDestFlags, COMBATLOG_OBJECT_REACTION_FRIENDLY)
			and "SPELL_AURA_APPLIED" == strEventType
			and self:FInList(varParam2, self.db.profile.strPartnerCC)
			and IsActiveBattlefieldArena()
	) then
		self:CheckAndPrintMessage(strDestName .. " is Sheeped!");
		self:CheckAndPlaySound(POLYMORPH_SOUND_FILE);
		fHandled = true;
	end

	-- Enemy player in an arena is innervated, play a sound
	if (not fHandled
			and 0 ~= bit.band(iDestFlags, COMBATLOG_OBJECT_REACTION_HOSTILE)
			and "SPELL_AURA_APPLIED" == strEventType
			and ((IsActiveBattlefieldArena()
					and self:FInList(varParam2, self.db.profile.strArenaPurge))
				or 0 ~= bit.band(iDestFlags, COMBATLOG_OBJECT_CONTROL_NPC)
					and self:FInList(varParam2, self.db.profile.strPvePurge))
	) then
		self:CheckAndPrintMessage(strDestName .. " has " .. varParam2 .. "!");
		self:CheckAndPlaySound(INNERVATE_SOUND_FILE);
		fHandled = true;
	end

	-- Play a sound when the Focus starts casting
	if (not fHandled
			and self:FIsSourceFocusOrTarget(iSourceFlags)
			and self:FIsSpellCastStart(strEventType, varParam1, varParam2, varParam3)
			and not self:FIsCasterOrSpellBlacklisted(strSourceName, iSourceFlags, varParam1, varParam2, varParam3)
			and not self:FHasBlacklistedAura(iSourceFlags, varParam1, varParam2, varParam3)
	) then
		if ((self.fIsPetInterrupt and self:FIsPetSpellAvailable(self.strInterruptSpellName))
			or (not self.fIsPetInterrupt and self:FIsSpellAvailable(self.strInterruptSpellName))
		) then
			self:CheckAndPrintMessage(strSourceName .. " is casting |cffff4444" .. varParam2 .. "|r!");
			self:CheckAndPlaySound(CASTING_SOUND_FILE);
			fHandled = true;
		end
	end

	-- Play a sound when a hostile player is attempting to CC you
	if (0 ~= bit.band(iSourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE)
			and 0 == bit.band(iSourceFlags, COMBATLOG_OBJECT_CONTROL_NPC)
			and self:FIsSpellCastStart(strEventType, varParam1, varParam2, varParam3)
			and self:FIsCCSpell(varParam1, varParam2, varParam3)
	) then
		if ((nil ~= self.strAntiCCSpellName or self:FIsSpellAvailable(self.strAntiCCSpellName))
				and (IsActiveBattlefieldArena() or 1 == IsSpellInRange(self.str30YardSpellName, strTarget))
		) then
			self:CheckAndPrintMessage(strSourceName .. " is casting CC: |cffffcc44" .. varParam2 .. "|r.");
			if (not fHandled) then
				self:CheckAndPlaySound(CC_SOUND_FILE);
				fHandled = true;
			end
		else
			self:CheckAndPrintMessage(strSourceName .. " is casting CC: |cffffcc44" .. varParam2 .. "|r (far away/inactionable).");
		end
	end

	-- Play sound when you interrupt a hostile target
	if (not fHandled
			and self.db.profile.fPositiveReinforcement
			and "SPELL_INTERRUPT" == strEventType
			and 0 ~= bit.band(iSourceFlags, COMBATLOG_OBJECT_AFFILIATION_MINE)
			and 0 ~= bit.band(iDestFlags, COMBATLOG_OBJECT_REACTION_HOSTILE)
	) then
		self:CheckAndPrintMessage("Successfully interrupted |cffaaffff" .. varParam5 .. "|r.");
		self:CheckAndPlaySound(INTERRUPTED_SOUND_FILE);
		fHandled = true;
	end
end
